
#include once "inc/iup.bi"

sub _init_ constructor
  IupOpen(0,0)
end sub

sub _exit_ destructor
  IupClose()
end sub

type BUTTON_KEY_STATUS field=1
  declare operator cast as string
  
  ' mouse
  declare function Left     as integer
  declare function Middle   as integer
  declare function Right    as integer
  declare function Button4  as integer
  declare function Button5  as integer
  declare function DblClick as integer
  ' keys
  declare function Shift    as integer
  declare function Ctrl     as integer
  declare function Alt      as integer
  declare function Sys      as integer

  private:
  as ubyte s,c,l,m,r,d,a,y,b4,b5
end type

operator BUTTON_KEY_STATUS.cast as string
  dim as string s
  if this.Left()     then s & = "(left) "
  if this.Middle()   then s & = "(midle) "
  if this.Right()    then s & = "(right) "
  if this.Button4()  then s & = "(button 4) "
  if this.Button5()  then s & = "(button 5) "
  if this.DblClick() then s & = "(dblclick) "
  if this.Shift()    then s & = "[SHIFT] "
  if this.Ctrl()     then s & = "[CTRL] "
  if this.Alt()      then s & = "[ALT] "
  if this.Sys()      then s & = "[SYS]"
  return s
end operator

function BUTTON_KEY_STATUS.Left as integer
  return (l<>32)
end function
function BUTTON_KEY_STATUS.Middle as integer
  return (m<>32)
end function
function BUTTON_KEY_STATUS.Right as integer
  return (r<>32)
end function
function BUTTON_KEY_STATUS.Button4 as integer
  return (b4<>32)
end function
function BUTTON_KEY_STATUS.Button5 as integer
  return (b5<>32)
end function
function BUTTON_KEY_STATUS.DblClick as integer
  return (d<>32)
end function
function BUTTON_KEY_STATUS.Shift as integer
  return (s<>32)
end function
function BUTTON_KEY_STATUS.Alt as integer
  return (a<>32)
end function
function BUTTON_KEY_STATUS.Ctrl as integer
  return (c<>32)
end function
function BUTTON_KEY_STATUS.Sys as integer
  return (y<>32)
end function

function button_cb cdecl (ih as IHandle ptr, button as integer, pressed as integer, x as integer, y as integer, status as BUTTON_KEY_STATUS) as integer
 ? "button_cb: " & button & "," & pressed & ", " & x & "x" & y & " " & status
  return IUP_DEFAULT
end function

'
' main
'
dim as IHandle ptr hButton = IupButton("Press any mousebutton and system keys",null)
IupSetCallback(hButton,"BUTTON_CB",cast(ICallback,@button_cb))

dim as IHandle ptr hDialog = IupDialog(hButton)

IupShow(hDialog)

IupMainLoop()

