' IUPfbGFX.bas

#include once "inc/iup.bi"

sub _init_ constructor
  IupOpen(0,0)
end sub

sub _exit_ destructor
  IupClose()
end sub


#define IUPRGB(r,g,b) ((cuint(b) shl 16) or (cuint(g) shl 8) or cuint(r) Or &hFF000000)
#define IUPRGBA(r,g,b,a) ((cuint(a) shl 24) or (cuint(b) shl 16) or (cuint(g) shl 8) Or cuint(r))

'
' main
'
screenres 1,1,32,,-1
dim as ubyte ptr pImg = imagecreate(100,100,0)
circle pImg,(50,50),50,IUPRGB(255,255,  0),,,,F
circle pImg,(25,30),12,IUPRGB(255,255,255),,,,F
circle pImg,(75,30),12,IUPRGB(255,255,255),,,,F
circle pImg,(25,30), 7,IUPRGB(  0,  0,  0),,,,F
circle pImg,(75,30), 7,IUPRGB(  0,  0,  0),,,,F
circle pImg,(50,50),28,IUPRGB(  0,  0,  0),1.57*2,1.57*4

' named iup image from fbgfx image
IupSetHandle ("img", IupImageRGBA( 100, 100, pImg+32 ))
' iup makes a copy so we can destroy the original buffer
imagedestroy(pImg)
' dialog with image label
IupShow(IupDialog(IupSetAttributes(IupLabel(NULL), "IMAGE=img")))

IupMainLoop()


