' ImageFormats.bas

#ifdef __FB_WIN32__
#define IUP_DLL
#endif

#include once "inc/iupim.bi"

' Initializes IUP
sub _init_ constructor
  IupOpen(0,0)
end sub
' Finishes IUP 
sub _exit_ destructor
  IupClose()
end sub

chdir exepath



#macro CreateFrameWithLabelFromImageFile(ext)
dim as IHandle ptr Image##ext = IupLoadImage("./media/renata." & #ext) : IupSetHandle(#ext, Image##ext)
dim as IHandle ptr Frame##ext = IupSetAttributes(IUPFrame(IupSetAttributes(IUpLabel(#ext),!"IMAGE=" & #ext)),!"TITLE=renata." & #ext)
#endmacro

CreateFrameWithLabelFromImageFile(bmp)
CreateFrameWithLabelFromImageFile(gif)
CreateFrameWithLabelFromImageFile(png)
CreateFrameWithLabelFromImageFile(pcx)
CreateFrameWithLabelFromImageFile(tga)
CreateFrameWithLabelFromImageFile(tiff)
CreateFrameWithLabelFromImageFile(jpg)

dim as IHandle ptr HBoxTop = IupHBox(Framebmp,IupFill(),Framegif,IupFill(),Framepng,IupFill(),Framepcx,NULL)
dim as IHandle ptr HBoxBottom = IupHBox(Frametga,IupFill(),Frametiff,IupFill(),Framejpg,NULL)
dim as IHandle ptr Dialog = IupDialog(IupVBox(HBoxTop,IupFill(),HBoxBottom,NULL))
IupSetAttributes(Dialog, !"TITLE=\"IupLoadImage Example" )
IupShowXY ( Dialog, IUP_CENTER, IUP_CENTER )
IupMainLoop()




