#ifndef __IUP_ASSERT_OPT_BI__
#define __IUP_ASSERT_OPT_BI__

' see copyright notice at the file iup.txt

' optional

#include once "iup.bi"

extern "c"
_DS_ iupAssert(expr as const zstring ptr, file as const zstring ptr, line_ as integer, func as const zstring ptr)
_DS_ iupError(format_ as const zstring ptr, ...)
end extern

#ifdef __FUNCTION__
#macro iupASSERT_(_expr) 
  if (_expr) then
  else
    iupAssert(#_expr, __FILE__, __LINE__, __FUNCTION__)
  end if  
#endmacro
#else
#macro iupASSERT_(_expr) 
  if (_expr) then
  else
    iupAssert(#_expr, __FILE__, __LINE__, NULL)
  end if  
#endif

#define iupERROR_(_msg) iupError(_msg)
#define iupERROR1_(_msg, _p1) iupError(_msg, _p1)
#define iupERROR2_(_msg, _p1, _p2) iupError(_msg, _p1, _p2)


#endif ' __IUP_ASSERT_OPT_BI__
