#ifndef __IUP_FOCUS_OPT_BI__
#define __IUP_FOCUS_OPT_BI__

' see copyright notice at the file iup.txt

' optional

' Keyboard Focus

extern "c"

' Utility to check if a control can have the keyboard input focus.
' To receive the focus must be interactive, has CANFOCUS=YES, is mapped, is visible and is active.
_DF_ iupFocusCanAccept(ih as Ihandle ptr) as integer 

' Call GETFOCUS_CB and FOCUS_CB.
_DS_ iupCallGetFocusCb(ih as Ihandle ptr)

' Call KILLFOCUS_CB and FOCUS_CB.
_DS_ iupCallKillFocusCb(ih as Ihandle ptr)

' Used only in iupKeyProcessNavigation
_DS_ iupFocusNext(ih as Ihandle ptr)
_DS_ iupFocusPrevious(ih as Ihandle ptr)

end extern

'void iupSetCurrentFocus(Ihandle *ih);
' Returns the next interactive brother. Independs if it can receive the focus.
'Ihandle* iupFocusNextInteractive(Ihandle *ih);

/' Other functions declared in iup.bi and implemented here. 
IupPreviousField
IupNextField
'/

#endif ' __IUP_FOCUS_OPT_BI__
