#ifndef __OLD_IM_BI__
#define __OLD_IM_BI__

' see copyright notice at the file iup.txt

#ifndef __IM_BI__
#error old_im.bi must be included from im.bi file !
#endif

enum
  IM_BMP, 
  IM_PCX,  
  IM_GIF, 
  IM_TIF, 
  IM_RAS, 
  IM_SGI, 
  IM_JPG, 
  IM_LED, 
  IM_TGA 
end enum

enum 
  IM_NONE = &H0000, 
  IM_DEFAULT = &H0100, 
  IM_COMPRESSED = &H0200
end enum                        

enum
  IM_RES_NONE,
  IM_RES_DPI,
  IM_RES_DPC
end enum

#define IM_ERR_READ IM_ERR_ACCESS
#define IM_ERR_WRITE IM_ERR_ACCESS
#define IM_ERR_TYPE IM_ERR_DATA
#define IM_ERR_COMP IM_ERR_COMPRESS

#define IM_INTERRUPTED -1
#define IM_ALL -1
#define IM_COUNTER_CB   0
#define IM_RESOLUTION_CB   1
#define IM_GIF_TRANSPARENT_COLOR_CB 0
#define IM_TIF_IMAGE_DESCRIPTION_CB 0

type imCallback            as function cdecl (filename as zstring ptr) as integer
type imFileCounterCallback as function cdecl (filename as zstring ptr, percent as integer, io as integer) as integer
type imResolutionCallback  as function cdecl (filename as zstring ptr, xres as double ptr, yres as double ptr, res_unit as integer ptr) as integer
type imGifTranspIndex      as function cdecl (filename as zstring ptr, transp_index as ubyte ptr) as integer
type imTiffImageDesc       as function cdecl (filename as zstring ptr, img_desc as zstring ptr) as integer

extern "c"

_DF_ imEncodeColor(red as ubyte, green as ubyte, blue as ubyte) as long
_DS_ imDecodeColor(red as ubyte ptr, green as ubyte ptr, blue as ubyte ptr, palette as long)
_DF_ imFileFormat(filename as zstring ptr, format as integer ptr) as integer
_DF_ imImageInfo(filename as zstring ptr, w as integer ptr, h as integer ptr, type as integer ptr, palette_count as integer ptr) as integer
_DF_ imLoadRGB(filename as zstring ptr, red as ubyte ptr, green as ubyte ptr, blue as ubyte ptr) as integer
_DF_ imSaveRGB(w as integer, h as integer, format as integer, red as ubyte ptr, green as ubyte ptr, blue as ubyte ptr, filename as zstring ptr) as integer
_DF_ imLoadMap(filename as zstring ptr, map as ubyte ptr, palette as long ptr) as integer
_DF_ imSaveMap(w as integer, h as integer, format as integer, map as ubyte ptr, palette_count as integer, palette as long ptr, filename as zstring ptr) as integer
_DS_ imRGB2Map(w as integer, h as integer, red as ubyte ptr, green as ubyte ptr, blue as ubyte ptr, map as ubyte ptr, palette_count as integer, palette as long ptr)
_DS_ imMap2RGB(w as integer, h as integer, map as ubyte ptr,  palette_count as integer, colors as long ptr, red as ubyte ptr, green as ubyte ptr, blue as ubyte ptr)
_DS_ imRGB2Gray(w as integer, h as integer, red as ubyte ptr, green as ubyte ptr, blue as ubyte ptr, map as ubyte ptr, grays as long ptr)
_DS_ imMap2Gray(w as integer, h as integer, map as ubyte ptr, palette_count as integer, colors as long ptr, grey_map as ubyte ptr, grays as long ptr)
_DS_ imResize(src_width as integer, src_height as integer, src_map as ubyte ptr, dst_width as integer, dst_height as integer, dst_map as ubyte ptr)
_DS_ imStretch(src_width as integer, src_height as integer, src_map as ubyte ptr, dst_width as integer, dst_height as integer, dst_map as ubyte ptr)
_DF_ imRegisterCallback(cb as imCallback, cb_id as integer, format as integer) as integer

end extern


#endif
