' Includes ANSI C libraries
#include once "crt.bi"

' Includes IUP libraries
#include once "inc/iup.bi"


sub _init_ constructor
  IupOpen(0,0)
end sub

sub _exit_ destructor
  IupClose()
end sub

' Defines released button's image
dim shared as ubyte pixmap_release(...) = _
{ _
       1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1, _
       1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,2, _
       1,1,3,3,3,3,3,3,3,3,3,3,3,3,2,2, _
       1,1,3,3,3,3,3,3,3,3,3,3,3,3,2,2, _
       1,1,3,3,3,3,3,3,3,3,3,3,3,3,2,2, _
       1,1,3,3,3,3,3,3,3,3,3,3,3,3,2,2, _
       1,1,3,3,3,3,3,3,3,3,3,3,3,3,2,2, _
       1,1,3,3,3,3,3,3,4,4,3,3,3,3,2,2, _
       1,1,3,3,3,3,3,4,4,4,4,3,3,3,2,2, _
       1,1,3,3,3,3,3,4,4,4,4,3,3,3,2,2, _
       1,1,3,3,3,3,3,3,4,4,3,3,3,3,2,2, _
       1,1,3,3,3,3,3,3,3,3,3,3,3,3,2,2, _
       1,1,3,3,3,3,3,3,3,3,3,3,3,3,2,2, _
       1,1,3,3,3,3,3,3,3,3,3,3,3,3,2,2, _
       1,1,3,3,3,3,3,3,3,3,3,3,3,3,2,2, _
       1,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2, _
       2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2 _
}

' Defines pressed button's image
dim shared as ubyte pixmap_press(...) = _
{ _
       1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1, _
       1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,2, _
       1,1,3,3,3,3,3,3,3,3,3,3,3,3,2,2, _
       1,1,3,3,3,3,3,3,3,3,3,3,3,3,2,2, _
       1,1,3,3,3,3,3,3,3,3,3,3,3,3,2,2, _
       1,1,3,3,3,3,3,3,3,3,3,3,3,3,2,2, _
       1,1,3,3,3,3,3,4,4,3,3,3,3,3,2,2, _
       1,1,3,3,3,3,4,4,4,4,3,3,3,3,2,2, _
       1,1,3,3,3,3,4,4,4,4,3,3,3,3,2,2, _
       1,1,3,3,3,3,3,4,4,3,3,3,3,3,2,2, _
       1,1,3,3,3,3,3,3,3,3,3,3,3,3,2,2, _
       1,1,3,3,3,3,3,3,3,3,3,3,3,3,2,2, _
       1,1,3,3,3,3,3,3,3,3,3,3,3,3,2,2, _
       1,1,3,3,3,3,3,3,3,3,3,3,3,3,2,2, _
       1,1,3,3,3,3,3,3,3,3,3,3,3,3,2,2, _
       1,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2, _
       2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2 _
} 

' Defines inactive button's image
dim shared as ubyte pixmap_inactive(...) = _
{ _
       1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1, _
       1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,2, _
       1,1,3,3,3,3,3,3,3,3,3,3,3,3,2,2, _
       1,1,3,3,3,3,3,3,3,3,3,3,3,3,2,2, _
       1,1,3,3,3,3,3,3,3,3,3,3,3,3,2,2, _
       1,1,3,3,3,3,3,3,3,3,3,3,3,3,2,2, _
       1,1,3,3,3,3,3,3,3,3,3,3,3,3,2,2, _
       1,1,3,3,3,3,3,3,4,4,3,3,3,3,2,2, _
       1,1,3,3,3,3,3,4,4,4,4,3,3,3,2,2, _
       1,1,3,3,3,3,3,4,4,4,4,3,3,3,2,2, _
       1,1,3,3,3,3,3,3,4,4,3,3,3,3,2,2, _
       1,1,3,3,3,3,3,3,3,3,3,3,3,3,2,2, _
       1,1,3,3,3,3,3,3,3,3,3,3,3,3,2,2, _
       1,1,3,3,3,3,3,3,3,3,3,3,3,3,2,2, _
       1,1,3,3,3,3,3,3,3,3,3,3,3,3,2,2, _
       1,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2, _
       2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2 _
}

function btn_on_off_cb cdecl (self as Ihandle ptr) as integer
  ' IUP handles
  dim as Ihandle ptr btn_image
    
  ' Recovers "btn_image" handle
  btn_image = IupGetHandle( "btn_image" )
  
  ' If the button with with image is active...
  if (strcmp( IupGetAttribute( btn_image, "ACTIVE" ), "YES" )=0) then
    ' Deactivates the button with image
    IupSetAttribute( btn_image, "ACTIVE","NO" )
  ' else it is inactive
  else
    ' Activates the button with image
    IupSetAttribute( btn_image, "ACTIVE", "YES" )
  end if

  ' Executed function successfully
  return IUP_DEFAULT
end function


function btn_image_button_cb cdecl (self as Ihandle ptr, b as integer, e as integer) as integer

  ' If the left button changed its state...
  if (b = IUP_BUTTON1) then
    ' IUP handles
    dim as Ihandle ptr text
    
    ' Recovers "text" handle
    text = IupGetHandle( "text" )
    
    ' If the button was pressed...
    if(e = 1) then
      ' Sets text's value
      IupSetAttribute( text, "VALUE", "Red button pressed" )
    
    ' else the button was released
    else       
      ' Sets text's value
      IupSetAttribute( text, "VALUE", "Red button released" )
    end if
  end if
  
  ' Executed function successfully
  return IUP_DEFAULT
end function


function btn_exit_cb cdecl ( self as Ihandle ptr) as integer
  ' Exits the program
  return IUP_CLOSE
end function

'
' main
'
var text = IupText( NULL )
IupSetAttribute( text, "EXPAND", "YES")
IupSetHandle ( "text", text )

var img_release = IupImage(16, 16, @pixmap_release(0))
IupSetAttribute( img_release, "1", "215 215 215" )
IupSetAttribute( img_release, "2", "40 40 40" )
IupSetAttribute( img_release, "3", "30 50 210" )
IupSetAttribute( img_release, "4", "240 0 0" )
IupSetHandle( "img_release", img_release )

var img_press = IupImage( 16, 16, @pixmap_press(0) )
IupSetAttribute( img_press, "1", "40 40 40" )
IupSetAttribute( img_press, "2", "215 215 215" )
IupSetAttribute( img_press, "3", "0 20 180" )
IupSetAttribute( img_press, "4", "210 0 0" )
IupSetHandle ( "img_press", img_press )

var img_inactive = IupImage( 16, 16, @pixmap_inactive(0) )
IupSetAttribute( img_inactive, "1", "215 215 215" )
IupSetAttribute( img_inactive, "2", "40 40 40" )
IupSetAttribute( img_inactive, "3", "100 100 100" )
IupSetAttribute( img_inactive, "4", "200 200 200" )
IupSetHandle ("img_inactive", img_inactive )

var btn_image = IupButton ( "Button with image", "btn_image")
IupSetAttribute( btn_image, "IMAGE"     , "img_release" )
IupSetAttribute( btn_image, "IMPRESS"   , "img_press"   )
IupSetAttribute( btn_image, "IMINACTIVE", "img_inactive")
IupSetAttribute( btn_image, "BUTTON_CB" , "btn_image_button")
IupSetHandle( "btn_image", btn_image )

var btn_big = IupButton( "Big useless button", "" )
IupSetAttribute( btn_big, "SIZE", "EIGHTHxEIGHTH" )

var btn_exit = IupButton( "Exit", "btn_exit")
var btn_on_off = IupButton( "on/off", "btn_on_off")

var hbox =IupHbox( btn_image, btn_on_off, btn_exit, NULL )
IupSetAttribute(hbox, "GAP", "5")

var frm1 = iupframe(hbox)
var frm2 = iupframe(text)
var frm3 = iupframe(btn_big)
var vbox = IupVbox( frm1, frm2, frm3, NULL)
'IupSetAttribute(vbox, "EXPANDCHILDREN", "YES")
IupSetAttribute(vbox, "GAP", "5")

var dlg = IupDialog( vbox)                             
IupSetAttributes( dlg, "TITLE = IUP-TEST" )
'IupSetAttributes( dlg, "MENUBOX = YES, MAXBOX = NO, MINBOX = NO" )
'IupSetAttributes ( dlg, "SIZE=HALFxHALF" )
'IupSetAttribute(dlg, "MARGIN", "10x10")
IupSetAttribute(dlg, "SHRINK", "YES")

IupSetCallback( btn_exit  , "ACTION", cast(Icallback,@btn_exit_cb ))
IupSetCallback( btn_on_off, "ACTION", cast(Icallback,@btn_on_off_cb ))
IupSetCallback( btn_image , "ACTION", cast(Icallback,@btn_image_button_cb ))

IupShowXY( dlg, IUP_CENTER, IUP_CENTER )
IupMainLoop()


