' Buttonbar.bas

#include once "inc/iup.bi"
#include once "inc/iupimglib.bi"

sub _init_ constructor
  IupOpen(0,0)
  IupImageLibOpen()
end sub

sub _exit_ destructor
  IupClose()
end sub

function FileExit cdecl (ih as Ihandle ptr) as integer
  ? "FileExit"
  return IUP_CLOSE
end function

#define EVENT(e_) IupSetAttributes(IupButton(NULL,e_),
#define IMAGE(i_) "FLAT=YES,IMAGE=" & i_
#define TIP(t_) & ",TIP=" & t_  
#define ACTIVE(a_) & ",ACTIVE=" & iif(a_,"YES","NO") )
#define TOOLBUTTON(e_,i_,t_,a_) EVENT(e_) IMAGE(i_)  TIP(t_) ACTIVE(a_)
#define TOOLSEPERATOR IupSetAttributes(IupButton(NULL,NULL),"ACTIVE=NO,FLAT=YES")

dim as IHandle ptr Buttonbar = IupHBox( _
  TOOLBUTTON("toolFileExit","IUP_ActionCancel","exit" ,1), _
  TOOLSEPERATOR, _
  TOOLBUTTON("toolFileNew"  ,"IUP_FileNew"    ,"new"  ,1), _
  TOOLBUTTON("toolFileOpen" ,"IUP_FileOpen"   ,"open" ,1), _
  TOOLBUTTON("toolFileSave" ,"IUP_FileSave"   ,"save" ,0), _
  TOOLBUTTON("toolFileClose","IUP_FileClose"  ,"close",0), _
  TOOLSEPERATOR, _
  TOOLBUTTON("toolEditUndo" ,"IUP_EditUndo"   ,"undo" ,1), _
  TOOLBUTTON("toolEditRedo" ,"IUP_EditRedo"   ,"redo" ,1), _
  TOOLSEPERATOR, _
  TOOLBUTTON("toolEditCut"  ,"IUP_EditCut"    ,"cut"  ,1), _
  TOOLBUTTON("toolEditCopy" ,"IUP_EditCopy"   ,"copy" ,1), _
  TOOLBUTTON("toolEditPaste","IUP_EditPaste"  ,"paste",1), _
  NULL)

' event handler
IupSetFunction("toolFileExit",@FileExit)
' ...

dim as IHandle ptr VBox = IupVBox(Buttonbar,IupSetAttributes(IupCanvas(NULL),"RASTERSIZE=640x480"),NULL)

IupShow(IupSetAttributes(IupDialog(VBox), !"TITLE=\"Buttonbar\""))
IupMainLoop()
