#include once "inc/iup.bi"
#include once "inc/iupcontrols.bi"
#include once "inc/iupimglib.bi"
#include once "inc/iupgl.bi"
#include once "inc/iup_object_opt.bi"

sub _init_ constructor
  IupOpen(0,0)
  IupControlsOpen()
  IupGLCanvasOpen()
  IupImageLibOpen()
end sub

sub _exit_ destructor
  IupClose()
end sub


type LAYOUTDIALOG_T
  ' destroy if the layout dialog is destroyed
  as integer destroy 
  as integer changed
  ' the selected dialog
  as IHandle ptr dialog
  ' elements from the layout dialog
  as IHandle ptr hTree
  as IHandle ptr hStatus
  as IHandle ptr hTimer
  as IHandle ptr hProperties  
  as IHandle ptr hCopy
end type
type PLAYOUTDIALOG as LAYOUTDIALOG_T ptr


'
' main
'
chdir exepath
dim as zstring ptr szError = IupLoad("layout2.led")
if szError <> NULL then
  IupMessage(!"%s\n", szError)
  end
end if

dim as IHandle_ ptr dialog=IupGetHandle("layout")
dim as IHandle ptr layout = IupLayoutDialog(dialog)
dim as PLAYOUTDIALOG pLayoutDialog = cptr(PLAYOUTDIALOG,IupGetAttribute(layout, "_IUP_LAYOUTDIALOG"))
IupSetAttribute(pLayoutDialog->hTree,"BGCOLOR","224 224 255")

dim as Ihandle ptr menu = IupGetAttributeHandle(layout, "MENU")
dim as IHandle ptr child = IupSubMenu("&FreeBASIC", _
                                 IupMenu( _
                                 IupSubMenu("Export", _
                                   IupMenu( _
                                     IupItem("BI...", NULL), _
                                     IupItem("BAS...", NULL), _
                                   NULL)),NULL))
print dialog->sig
print *dialog->iclass->name  
IupAppend(menu,child) 
IupMap(child)

IupShowXY(layout, IUP_CENTER, IUP_CENTER) 
IupMainLoop()





