' ImageMenu.bas

#include once "inc/iup.bi"
#include once "inc/iupimglib.bi"

sub _init_ constructor
  IupOpen(0,0)
  IupImageLibOpen()
end sub

sub _exit_ destructor
  IupClose()
end sub


function mnuFileExit cdecl (ih as Ihandle ptr) as integer
  ? "mnuFileExit"
  return IUP_CLOSE
end function

#define MENUITEM(t_,e_,i_) IupSetAttributes(IupItem(t_,e_),"IMAGE=" & i_)

dim as IHandle ptr MyMenu = _
IupMenu( _
  IupSubmenu("&File", _
             IupMenu( _
                     MENUITEM(!"&New\tCtrl+N","mnuFileNew","IUP_FileNew"), _
                     MENUITEM(!"&Open ...\tCtrl+O","mnuFileOpen","IUP_FileOpen"), _
                     IupSeparator(), _
                     MENUITEM(!"&Save\tCtrl+S","mnuFileSave","IUP_FileSave"), _
                     MENUITEM("Save &all","mnuFileSaveAll","IUP_FileSaveAll"), _
                     IupSeparator(), _
                     MENUITEM("&Close","mnuFileClose","IUP_FileClose"), _
                     MENUITEM("Close a&ll","mnuFileCloseAll","IUP_FileCloseAll"), _
                     IupSeparator(), _
                     MENUITEM("E&xit","mnuFileExit","IUP_ActionCancel"), _
                     NULL) _ 
             ), _
    IupSubmenu("&Edit", _
             IupMenu( _
                     MENUITEM(!"&Undo\tCtrl+U","mnuEditUndo","IUP_EditUndo"), _
                     MENUITEM(!"&Redo\tCtrl+Z","mnuEditRedo","IUP_EditRedo"), _
                     IupSeparator(), _
                     MENUITEM(!"&Cut\tCtrl+X","mnuEditCut","IUP_EditCut"), _
                     IupSeparator(), _
                     MENUITEM(!"Co&py\tCtrl+C","mnuEditCopy","IUP_EditCopy"), _
                     MENUITEM(!"&Paste\tCtrl+V","mnuEditPaste","IUP_EditPaste"), _
                     NULL) _ 
             ), _
    IupSubmenu("&Help", _
             IupMenu( _
                     MENUITEM(!"&Help\tF1","mnuHelp","IUP_MessageHelp"), _
                     NULL) _ 
             ), _
  NULL)

' menu event handler
IupSetFunction("mnuFileExit"   ,@mnuFileExit)
' ...

' create a named menu handle for the dialog
IupSetHandle("MyMenu", MyMenu)

dim as IHandle ptr clientregion = IupHBox(IupSetAttributes(IupCanvas(NULL),"RASTERSIZE=640x480"),NULL)


dim as IHandle ptr dlg = IupDialog(clientregion)
IupSetAttribute(dlg, "TITLE", "MenuImages")
' add the menu to the dialog via named handle
IupSetAttribute(dlg, "MENU", "MyMenu")

IupShow(dlg)
IupMainLoop()
