#ifndef __FTPolygonGlyph_bi__
#define __FTPolygonGlyph_bi__

extern "c"

/'*
 * Create a specialisation of FTGLglyph for creating tessellated
 * polygon glyphs.
 *
 * @param glyph The Freetype glyph to be processed
 * @param outset outset contour size
 * @param useDisplayList Enable or disable the use of Display Lists
 *                       for this glyph
 *                       <code>true</code> turns ON display lists.
 *                       <code>false</code> turns OFF display lists.
 * @return  An FTGLglyph* object.
 '/
declare function ftglCreatePolygonGlyph(glyph as FT_GlyphSlot, outset as single, useDisplayList as integer) as FTGLglyph ptr

end extern

#endif
