#ifndef __CD_CAIRO_BI__
#define __CD_CAIRO_BI__

' see copyright notice at the file iup.txt

#include once "cd.bi"

extern "c"

/' Some of these context can be used directly or by cdInitContextPlus,
   as  CD_NATIVEWINDOW, CD_IMAGE, CD_EMF, CD_PRINTER and CD_DBUFFER.
   The others only directly. 
'/

_DF_ cdContextCairoNativeWindow() as cdContext ptr 
_DF_ cdContextCairoImage() as cdContext ptr
_DF_ cdContextCairoDBuffer() as cdContext ptr
_DF_ cdContextCairoPrinter() as cdContext ptr
_DF_ cdContextCairoPS() as cdContext ptr
_DF_ cdContextCairoPDF() as cdContext ptr
_DF_ cdContextCairoSVG() as cdContext ptr
_DF_ cdContextCairoImageRGB() as cdContext ptr
_DF_ cdContextCairoEMF() as cdContext ptr

end extern

#define CD_CAIRO_NATIVEWINDOW cdContextCairoNativeWindow()
#define CD_CAIRO_IMAGE cdContextCairoImage()
#define CD_CAIRO_DBUFFER cdContextCairoDBuffer()
#define CD_CAIRO_PRINTER cdContextCairoPrinter()
#define CD_CAIRO_PS cdContextCairoPS()
#define CD_CAIRO_PDF cdContextCairoPDF()
#define CD_CAIRO_SVG cdContextCairoSVG()
#define CD_CAIRO_IMAGERGB cdContextCairoImageRGB()
#define CD_CAIRO_EMF cdContextCairoEMF()


#endif
