#ifndef __ftgl_bi__
#define __ftgl_bi__
/'
 * FTGL - OpenGL font library
 *
 * Copyright (c) 2001-2004 Henry Maddocks <ftgl@opengl.geek.nz>
 * Copyright (c) 2008 Sam Hocevar <sam@zoy.org>
 * Copyright (c) 2008 Sean Morrison <learner@brlcad.org>
 *
 * Permission is hereby granted, free of charge, to any person obtaining
 * a copy of this software and associated documentation files (the
 * "Software"), to deal in the Software without restriction, including
 * without limitation the rights to use, copy, modify, merge, publish,
 * distribute, sublicense, and/or sell copies of the Software, and to
 * permit persons to whom the Software is furnished to do so, subject to
 * the following conditions:
 *
 * The above copyright notice and this permission notice shall be
 * included in all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
 * EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
 * MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
 * IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY
 * CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,
 * TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
 * SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
 '/

' We need the Freetype headers
#include once "freetype2/freetype.bi"

#inclib "ftgl"
#inclib "z"
#inclib "stdc++"

#define FTGL_RENDER_FRONT &H0001
#define FTGL_RENDER_BACK  &H0002
#define FTGL_RENDER_SIDE  &H0004
#define FTGL_RENDER_ALL   &Hffff

#define FTGL_ALIGN_LEFT    0
#define FTGL_ALIGN_CENTER  1
#define FTGL_ALIGN_RIGHT   2
#define FTGL_ALIGN_JUSTIFY 3

#include once "FTGL/FTGlyph.bi"
#include once "FTGL/FTBitmapGlyph.bi"
#include once "FTGL/FTExtrdGlyph.bi"
#include once "FTGL/FTOutlineGlyph.bi"
#include once "FTGL/FTPixmapGlyph.bi"
#include once "FTGL/FTPolyGlyph.bi"
#include once "FTGL/FTTextureGlyph.bi"

#include once "FTGL/FTFont.bi"
#include once "FTGL/FTGLBitmapFont.bi"
#include once "FTGL/FTBufferFont.bi"
#include once "FTGL/FTGLExtrdFont.bi"
#include once "FTGL/FTGLOutlineFont.bi"
#include once "FTGL/FTGLPixmapFont.bi"
#include once "FTGL/FTGLPolygonFont.bi"
#include once "FTGL/FTGLTextureFont.bi"

#include once "FTGL/FTLayout.bi"
#include once "FTGL/FTSimpleLayout.bi"

#endif  '  __ftgl_bi__
