#ifndef __iupcontrols_bi__
#define __iupcontrols_bi__

' see copyright notice at the file iup.txt

#include once "iup.bi"
#include once "iupcd.bi" ' IupDial() use libcd.a also

#inclib "iupcontrols"

/' Used by IupColorbar '/
#define IUP_PRIMARY -1
#define IUP_SECONDARY -2

extern "C"

_DF_ IupControlsOpen() as integer

_DF_ IupColorbar() as Ihandle ptr
_DF_ IupCells() as Ihandle ptr
_DF_ IupColorBrowser() as Ihandle ptr
_DF_ IupGauge() as Ihandle ptr
_DF_ IupDial(type as zstring ptr) as Ihandle ptr
_DF_ IupMatrix(action as zstring ptr) as Ihandle ptr

/' IupMatrix utilities '/
_DS_ IupMatSetAttribute  (ih as Ihandle ptr, name as const zstring ptr, lin as integer, col as integer, value as const zstring ptr)
_DS_ IupMatStoreAttribute(ih as Ihandle ptr, name as const zstring ptr, lin as integer, col as integer, value as const zstring ptr)
_DF_ IupMatGetAttribute  (ih as Ihandle ptr, name as const zstring ptr, lin as integer, col as integer) as zstring ptr
_DF_ IupMatGetInt        (ih as Ihandle ptr, name as const zstring ptr, lin as integer, col as integer) as integer
_DF_ IupMatGetFloat      (ih as Ihandle ptr, name as const zstring ptr, lin as integer, col as integer) as single
_DS_ IupMatSetfAttribute (ih as Ihandle ptr, name as const zstring ptr, lin as integer, col as integer, format as const zstring ptr, ...)

end extern

#endif
